unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, SortGrid;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    SaveDialog1: TSaveDialog;
    SortGrid1: TSortGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

function RandomString(ALength: Integer): String;
var
  i: Integer;
  n: Integer;
begin
  Result := '';
  for i:=1 to ALength do begin
    n := Random(29);
    case n of
      26 : Result := Result + '';
      27 : Result := Result + '';
      28 : Result := Result + '';
      29 : Result := Result + '';
      else Result := Result + char(n + ord('a'));
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  x, y:      integer;
  ClickedOK: boolean;
  Zeilen:    string;
  Grid:      TSortGrid;

begin
  try
    Grid := SortGrid1;

    Application.ProcessMessages;

    Randomize;

    Zeilen := Edit1.Text;

    //ClickedOK := InputQuery('Insert Test-Data into Grid', 'Insert how many lines?', Zeilen);

    ClickedOK := true;
    if ClickedOK then
    begin
      Grid.Columns.Clear;
      for x := 0 to 6 do
      begin
        Grid.Columns.Add;
      end;

      Grid.RowCount := StrToIntDef(Zeilen, 1);
      Grid.Columns[0].Title.Caption:='No.';
      Grid.Columns[1].Title.Caption:='Integer';
      Grid.Columns[2].Title.Caption:='Float';
      Grid.Columns[3].Title.Caption:='Date';
      Grid.Columns[4].Title.Caption:='DateTime';
      Grid.Columns[5].Title.Caption:='Time';
      Grid.Columns[6].Title.Caption:='String';
      Grid.RowCount := Grid.RowCount + Grid.FixedRows;
      //Grid.Options2:=  Grid.Options2 + [goShowSortArrows];
      Application.ProcessMessages;
    end;

    (* Testdaten eintragen *)
    (* Zeile *)
    for x := 1 to Grid.RowCount - 1 do
    begin
      (* Spalte *)
      for y := 0 to Grid.ColCount - 1 do
      begin
        case y of
          0: (* integer *)
          begin
            Grid.Cells[y, x] := IntToStr(x);
          end;
          1: (* integer *)
          begin
            Grid.Cells[y, x] := IntToStr(Random(10000));
          end;
          2: (* Float *)
          begin
            Grid.Cells[y, x] := FormatFloat('0.00', Random(10000) * Random());
          end;
          3: (* Date *)
          begin
            Grid.Cells[y, x] := FormatDateTime('dd.mm.yyyy', Date + x);
          end;
          4: (* DateTime *)
          begin
            Grid.Cells[y, x] := FormatDateTime('dd.mm.yyyy hh:nn:ss', Date +  Random());
          end;
          5: (* Time *)
          begin
            Grid.Cells[y, x] := FormatDateTime('hh:nn:ss', time +  Random());
          end;
          6: (* String *)
          begin
            //Grid.Cells[y, x] := 'We don''t use Embarcadero ' + IntToStr(x);
            Grid.Cells[y, x] := RandomString(Random(64)+1);
          end;
        end;
      end;
    end;

    //Grid.AutoSizeColumns;
    Grid.SetFocus;
    Application.ProcessMessages;

    ShowMessage('Click on column title to sort ' + Zeilen + ' rows!');

  finally
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    Screen.Cursor := crHourGlass;
    SortGrid1.SaveToCSVFile(SaveDialog1.Filename, ';', true, false);
    Screen.Cursor := crDefault;
  end;
end;

end.

